---
title: FileSystemDirectoryHandle.resolve()
slug: Web/API/FileSystemDirectoryHandle/resolve
tags:
  - Directory
  - File
  - File System Access API
  - FileSystemDirectoryHandle
  - Method
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>resolve()</code></strong> method of the {{domxref("FileSystemDirectoryHandle")}} interface returns an {{jsxref('Array')}} of directory names from the parent handle to the specified child entry, with the name of the child entry as the last array item.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>pathArr</var> = FileSystemDirectoryHandle.resolve(possibleDescendant);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>possibleDescendant</dt>
 <dd>The {{domxref('FileSystemHandle.name')}} of the {{domxref('FileSystemHandle')}} from which to return the relative path.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} which resolves with an {{jsxref('Array')}} of {{jsxref('USVString','strings')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>No exceptions are thrown.</p>

<h2 id="Examples">Examples</h2>

<p>The following asynchronous function uses <code>resolve()</code> to find the path to a chosen file, relative to a specified directory handle.</p>

<pre class="brush: js notranslate">async function returnPathDirectories(directoryHandle) {

  // Get a file handle by showing a file picker:
  const handle = await self.showOpenFilePicker();
  if (!handle) {
    // User cancelled, or otherwise failed to open a file.
    return;
  }

  // Check if handle exists inside our directory handle
  const relativePaths = await directoryHandle.resolve(handle);

  if (relativePath === null) {
    // Not inside directory handle
  } else {
    // relativePath is an array of names, giving the relative path

    for (const name of relativePaths) {
      // log each entry
      console.log(name);
    }
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API','#dom-filesystemdirectoryhandle-resolve','resolve')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryHandle.resolve")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
